﻿package  
{
	import flash.display.MovieClip;
	import flash.events.Event;
	
	/**
	 * The main document class of the FlightSim tutorial. This class keeps track of
	 * entities in the game and handles calling their update loop.
	 * 
	 * @author Skyler
	 */
	public class FlightSim extends MovieClip
	{
		private static var instance:FlightSim;		
		private var enemyContainer:MovieClip;
		private var score:int = 0;
		
		public function FlightSim() 
		{
			instance = this;		
			enemyContainer = new MovieClip();
			
			this.addEventListener(Event.ADDED, Init);		
			this.addEventListener(Event.ENTER_FRAME, GameLoop);
		}
		
		public function Init(evt:Event) {
			stage.addChild(enemyContainer);
			
			this.removeEventListener(Event.ADDED, Init);
		}
		
		
		private function GameLoop(evt:Event) {
			if (Math.random() < 0.05) {
				var b:Baddie = new Baddie(Math.random() * stage.stageWidth, -40);				
				enemyContainer.addChild(b);
			}
		}
		
		public function AddScore(points:int) {
			score += points;
			
			var scoreText:String = ""+score;
			while (scoreText.length < 13)
				scoreText = "0" + scoreText;
								
			PlayerScore.text = scoreText; 
			
		}
		
		public function GetEnemyContainer():MovieClip {
			return enemyContainer;
		}
		
		static public function GetInstance():FlightSim {
			return instance;
		}
		
	}
	
}